<?php
// This file is part of Moodle - http://moodle.org/
//
// Moodle is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Moodle is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.

/**
 * Simulatore contabilità
 *
 * @package    mod_mtcontabilita
 * @copyright  2026 Mediatouch 2000 Srl <https://www.mediatouch.it>
 * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
 * @author     Marco Cappuccio <m.cappuccio@mediatouch.it>
 */

namespace mod_mtcontabilita\output;

/**
 * Class session_description_modal
 */
class session_description_modal implements \templatable, \renderable {

    /**
     * @var \stdClass $session
     */
    private $session;

    /**
     * @var \context_module $context
     */
    private $context;

    /**
     * Constructor
     *
     * @param \stdClass $session
     * @param \context_module $context
     */
    public function __construct(\stdClass $session, \context_module $context) {
        $this->session = $session;
        $this->context = $context;
    }

    /**
     * Exports for template.
     *
     * @param \renderer_base $output
     * @return array|\stdClass
     */
    public function export_for_template(\renderer_base $output): array {
        global $USER;

        $data = [];

        $datetime = new session_datetime($this->session);
        $data += $datetime->export_for_template($output);

        $capacity = new session_capacity($this->session, $this->context);

        $data += $capacity->export_for_template($output);

        if ($submissions = mtcontabilita_get_user_submissions($this->session->mtcontabilita, $USER->id)) {
            foreach ($submissions as $s) {
                if ($s->sessionid == $this->session->id) {
                    $this->session->usersubmission = $s;
                }
            }
        } else {
            $this->session->usersubmission = null;
        }

        $status = new session_status($this->session);
        $data += $status->export_for_template($output);

        $description = new session_description($this->session, $this->context);
        $data += $description->export_for_template($output);

        return $data;
    }
}
